--Settings:
--------------------------------------------------------------------------------------------------------------------
-- Bar width, Bar height, Fontsize and Transparency can be set ingame (Esc -> Interface -> AddOns -> PowertTrackerBar)
--------------------------------------------------------------------------------------------------------------------
PTBarSettings = {
	StatusTex = [[Interface\AddOns\PowerTrackerBar\Media\Bubble.tga]],
	PanelTex = [[Interface\AddOns\PowerTrackerBar\Media\Flat.tga]],
	font = [[Interface\AddOns\PowerTrackerBar\Media\font.ttf]],
}

local Focus_prediction = 1	-- use Focus prediction for Hunter (Cobra, Steady, Focusing Shot) (1 = yes; 0 = no)

--[[
I removed the option to set your own bar color, if you want it back drop me a comment on:

http://www.curse.com/addons/wow/powertrackerbar

or

http://www.wowinterface.com/downloads/info23639.html

]]
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------

--[[
Changelog:

PowerTrackerBar v60200.7:

- Option to set height and width in pixels
- The position of the frame is now saved in the SavedVariables (instead of layout.txt)

----------------------------
PowerTrackerBar v60200.6:

- Option to change the Bar Color to Power Color (E.g. As a warrior to red for rage.)

----------------------------

PowerTrackerBar v60200.51:

- Bugfix

----------------------------

PowerTrackerBar v60200.5:

- Option to hide the bar out of combat

- Option to merge Combopoints with Anticipation stacks. E.g. 5cp + 2 Anticipation gets displayed as 7.

----------------------------

PowerTrackerBar v60200.4:

- Hide bar in Pet Battle

- Resize the bar via /ptb

- As a druid only display combopoints while in Cat form or if you still have combopoints left while in another form

----------------------------

PowerTrackerBar v60200.3:

- Opacity and Font size can be set ingame (Esc -> Interface -> AddOns -> PowertTrackerBar)

- Anticipation stacks are only displayed when the talent Anticipation is selected

----------------------------

PowerTrackerBar v60200.2:

- Bar width and height can be set ingame (Esc -> Interface -> AddOns -> PowertTrackerBar)

- Focus prediction for Steady Shot / Cobra Shot / Focusing Shot.

----------------------------

PowerTrackerBar v60200.1:

- Class Color

]]

PowerTrackerBarSettings = PowerTrackerBarSettings or {}
PowerTrackerBar = {};
PowerTrackerBar.panel = CreateFrame( "Frame", "PowerTrackerBarPanel", UIParent );
PowerTrackerBar.panel.name = "PowerTrackerBar";
InterfaceOptions_AddCategory(PowerTrackerBar.panel);

local _, class = UnitClass("player")

--Background:
local PTBarBG = CreateFrame("Frame", "PTBarBG", UIParent)
PTBarBG:SetBackdrop({
	bgFile = PTBarSettings.PanelTex, 
	edgeFile = PTBarSettings.PanelTex, 
	tile = false, tileSize = 0, edgeSize = 1, 
	insets = { left = -1, right = -1, top = -1, bottom = -1}
})
PTBarBG:SetMovable(true)
PTBarBG:SetResizable(true)
PTBarBG:SetClampedToScreen(true)
--PTBarBG:SetUserPlaced(true)
PTBarBG:RegisterEvent("VARIABLES_LOADED")
PTBarBG:SetScript("OnEvent", function(self)
		PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTBarBG_yOfs == nil then
		PTBarBG:SetPoint("BOTTOMLEFT", UIParent, "CENTER", -200, -50)
	else
		PTBarBG:SetPoint(PowerTrackerBarSettings.PTBarBG_point, UIParent, PowerTrackerBarSettings.PTBarBG_relativePoint, PowerTrackerBarSettings.PTBarBG_xOfs, PowerTrackerBarSettings.PTBarBG_yOfs)
	end
	
	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		PTBarBG:SetWidth(181)
	else
		PTBarBG:SetWidth(PowerTrackerBarSettings.SliderWidthvalue)
	end	
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		PTBarBG:SetHeight(26)
	else
		PTBarBG:SetHeight(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		PTBarBG:SetBackdropColor(0,0,0,.7)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,.7)
	else
		PTBarBG:SetBackdropColor(0,0,0,PowerTrackerBarSettings.SliderTransparencyvalue)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,PowerTrackerBarSettings.SliderTransparencyvalue)
	end
end)

--Hide in PetBattle
PetBattleFrame:HookScript("OnShow",function()
	PTBarBG:Hide()
end)
PetBattleFrame:HookScript("OnHide",function()
	PTBarBG:Show()
end)

--Bar:
local TimeSinceLastUpdate = 1
local PTBar = CreateFrame("StatusBar", "PTBar", PTBarBG)
PTBar:SetStatusBarTexture(PTBarSettings.StatusTex)
PTBar:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)
PTBar:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)
PTBar:SetScript("OnUpdate", function(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	if (TimeSinceLastUpdate >= 1) then
		self:SetMinMaxValues(0, UnitPowerMax("player"))
		self:SetValue(UnitPower("player"))
	end
end)
PTBar:RegisterEvent("ADDON_LOADED")
PTBar:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
PTBar:SetScript("OnEvent", function(self)
	
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	PowerTrackerBar_PowerColor = PowerTrackerBarSettings.PowerColorvalue
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		PowerTrackerBar_Transparency = .7
	else
		PowerTrackerBar_Transparency = PowerTrackerBarSettings.SliderTransparencyvalue
	end
	
	if PowerTrackerBarSettings.PowerColorvalue == nil then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif PowerTrackerBarSettings.PowerColorvalue == false then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif PowerTrackerBarSettings.PowerColorvalue == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];		
		if ( info ) then --The PowerBarColor takes priority			
			r, g, b = info.r, info.g, info.b;
		else
			if ( not altR) then
				-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
				info = PowerBarColor[powerType] or PowerBarColor["MANA"];
				r, g, b = info.r, info.g, info.b;
			else
				r, g, b = altR, altG, altB;
			end
		end
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, 16, "THINOUTLINE")
	else
		PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, PowerTrackerBarSettings.SliderFontsizevalue, "THINOUTLINE")
	end
end)



--Text:
local PTBar_StatusText = CreateFrame("StatusBar", "PTBar_StatusText", PTBarBG)
PowerTrackerBar_StatusText = PTBar_StatusText:CreateFontString(nil, "OVERLAY")
PowerTrackerBar_StatusText:SetPoint("CENTER", PTBarBG, "CENTER")

if class == "MONK" then
	local function MONK_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 12)
		PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
	end
	PTBar_StatusText:SetScript("OnEvent", MONK_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "ROGUE" then
	local function ROGUE_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local anticipation_selected = select(4, GetTalentInfoByID(19250, GetActiveSpecGroup()))
		local anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
		
		if class == "ROGUE" then anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
			if not anticipation_stacks then anticipation_stacks = 0 end
		end		
		if anticipation_selected == true then
			if PowerTrackerBarMergeCP:GetChecked() == true then
				PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower+anticipation_stacks)
			elseif PowerTrackerBarMergeCP:GetChecked() == false then
				PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower .. ' - ' .. anticipation_stacks)
			end
		else
			PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
		end
	end
	PTBar_StatusText:SetScript("OnEvent", ROGUE_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	PTBar_StatusText:RegisterEvent("UNIT_AURA")
	PTBar_StatusText:RegisterEvent("PLAYER_STARTED_MOVING")
	
elseif class == "DRUID" then
	local function DRUID_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local ShapeshiftForm = GetShapeshiftForm()
		
		if ShapeshiftForm == 2 or altpower >= 1 then
			PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
		else
			PowerTrackerBar_StatusText:SetText(Power)
		end			
	end
	PTBar_StatusText:SetScript("OnEvent", DRUID_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	PTBar_StatusText:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
	
elseif class == "PALADIN" then
	local function PALADIN_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 9)
		PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
	end
	PTBar_StatusText:SetScript("OnEvent", PALADIN_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "HUNTER" then
	local function HUNTER_TEXT()
		local Power = (UnitPower("player"))
		local PlayerCast, _, _, _, _, endTime = UnitCastingInfo("player")
		
		if (PlayerCast == "Cobra Shot" or PlayerCast == "Steady Shot" or PlayerCast == "Focusing Shot") and Focus_prediction == 1 then --Focus prediction for hunters (text)
			local regen = GetPowerRegen()
			local timeLeft = endTime/1000 - GetTime()
			local cast_regen = (regen * timeLeft)
			if PlayerCast == "Cobra Shot" or PlayerCast == "Steady Shot" then
				PowerTrackerBar_StatusText:SetText(Power.. '(' .. (Power+ceil(cast_regen+14)) .. ')')
			elseif PlayerCast == "Focusing Shot" then
				PowerTrackerBar_StatusText:SetText(Power.. '(' .. (Power+ceil(cast_regen+50)) .. ')')
			end
		else PowerTrackerBar_StatusText:SetText(Power)
		end		
	end
	PTBar_StatusText:SetScript("OnEvent", HUNTER_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
else
	local function else_TEXT()
		local Power = (UnitPower("player"))
		PowerTrackerBar_StatusText:SetText(Power)
	end
	PTBar_StatusText:SetScript("OnEvent", else_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
end

--Focus prediction for hunters (bar):
if class == "HUNTER" and Focus_prediction == 1 then
	PTBar_prediction = CreateFrame("StatusBar", "PTBar_prediction", PTBarBG)
	PTBar_prediction:SetStatusBarTexture(PTBarSettings.StatusTex)
	PTBar_prediction:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)
	PTBar_prediction:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)
	
	PTBar_prediction:SetScript("OnUpdate", function(self, elapsed)		
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if (TimeSinceLastUpdate >= 1) then
			self:SetMinMaxValues(0, UnitPowerMax("player"))	
			if UnitCastingInfo("player") == "Cobra Shot" or UnitCastingInfo("player") == "Steady Shot" or UnitCastingInfo("player") == "Focusing Shot" then
				if UnitCastingInfo("player") == "Cobra Shot" or UnitCastingInfo("player") == "Steady Shot" then	
					self:SetValue((UnitPower("player")+14))
				elseif UnitCastingInfo("player") == "Focusing Shot" then
					self:SetValue(UnitPower("player")+50)
				end
			else self:SetValue(0)
			end
		end
	end)
	PTBar_prediction:RegisterEvent("PLAYER_ENTERING_WORLD")
	PTBar_prediction:SetScript("OnEvent", function(self)	
		PowerTrackerBarSettings = PowerTrackerBarSettings or {}
		
		if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
			PowerTrackerBar_predictiontransparency = .7 / 1.5
		else
			PowerTrackerBar_predictiontransparency = PowerTrackerBarSettings.SliderTransparencyvalue / 1.5
		end
		
		if PowerTrackerBarSettings.PowerColorvalue == nil then
			local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		elseif PowerTrackerBarSettings.PowerColorvalue == false then
			local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		elseif PowerTrackerBarSettings.PowerColorvalue == true then
			local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
			local info = PowerBarColor[powerToken];		
			if ( info ) then --The PowerBarColor takes priority			
				r, g, b = info.r, info.g, info.b;
			else
				if ( not altR) then
					-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
					info = PowerBarColor[powerType] or PowerBarColor["MANA"];
					r, g, b = info.r, info.g, info.b;
				else
					r, g, b = altR, altG, altB;
				end
			end
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		end
	end)
end