local _, class = UnitClass("player")

-- Text Settings Headline (PowerTrackerBar Settings:)
local Settingstext = PowerTrackerBar.panel:CreateFontString("Settingstext")
Settingstext:SetFontObject('GameFontNormalLarge')
Settingstext:SetPoint("TOPLEFT", 5,-5)
Settingstext:SetText('PowerTrackerBar Settings:')

-- Text Settings Small (Type /ptb to unlock)
local Settingstext2 = PowerTrackerBar.panel:CreateFontString("Settingstext2")
Settingstext2:SetFontObject('GameFontNormalSmall')
Settingstext2:SetPoint("TOPLEFT", 5,-30)
Settingstext2:SetText('Type /ptb to unlock')


-- Slider for Width
local SliderWidth = CreateFrame("Slider","PowerTrackerBarSliderWidth",PowerTrackerBar.panel,'OptionsSliderTemplate') 
local EditBoxWidth = CreateFrame("EditBox","PowerTrackerBarEditBoxWidth",SliderWidth,'InputBoxTemplate')
local OkButtonWidth = CreateFrame("Button","PowerTrackerBarButtonToGolbal",EditBoxWidth,'UIPanelButtonTemplate')
EditBoxWidth:SetPoint("Right",60,0)
EditBoxWidth:SetWidth(40)
EditBoxWidth:SetHeight(20)
EditBoxWidth:SetAutoFocus(false)
SliderWidth:SetPoint("TOPLEFT",40,-70)
_G[SliderWidth:GetName() .. 'Low']:SetText('40');
_G[SliderWidth:GetName() .. 'High']:SetText('500');
SliderWidth:SetMinMaxValues(40, 500)
SliderWidth:SetValueStep(1)
-- Save the Width in the SavedVariables and set the Width ingame
SliderWidth:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderWidthvalue = value
	
	PTBarBG:SetWidth(value)
	EditBoxWidth:SetText(value)
	_G[SliderWidth:GetName() .. 'Text']:SetText('Bar Width: '.. ceil(SliderWidth:GetValue()));
end)

OkButtonWidth:SetPoint("Right",40,0)
OkButtonWidth:SetText("OK")
OkButtonWidth:SetScript("OnClick", function(self)

	local value = ceil(EditBoxWidth:GetText())
	
	PowerTrackerBarSettings.SliderWidthvalue = value
	
	PTBarBG:SetWidth(value)
	SliderWidth:SetValue(value)
end
);

--Slider for Height
local SliderHeight = CreateFrame("Slider","PowerTrackerBarSliderHeight",PowerTrackerBar.panel,'OptionsSliderTemplate')
local EditBoxHeight = CreateFrame("EditBox","PowerTrackerBarEditBoxWidth",SliderHeight,'InputBoxTemplate')
local OkButtonHeight = CreateFrame("Button","PowerTrackerBarButtonToGolbal",EditBoxHeight,'UIPanelButtonTemplate')
EditBoxHeight:SetPoint("Right",60,0)
EditBoxHeight:SetWidth(40)
EditBoxHeight:SetHeight(20)
EditBoxHeight:SetAutoFocus(false)
SliderHeight:SetPoint("TOPLEFT",40,-125)
_G[SliderHeight:GetName() .. 'Low']:SetText('20');
_G[SliderHeight:GetName() .. 'High']:SetText('100');
SliderHeight:SetMinMaxValues(20, 100)
SliderHeight:SetValueStep(1)
-- Save the Height in the SavedVariables and set the Height ingame
SliderHeight:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderHeightvalue = value
	
	PTBarBG:SetHeight(value)
	EditBoxHeight:SetText(value)
	_G[SliderHeight:GetName() .. 'Text']:SetText('Bar Height: '.. ceil(SliderHeight:GetValue()));
end)

OkButtonHeight:SetPoint("Right",40,0)
OkButtonHeight:SetText("OK")
OkButtonHeight:SetScript("OnClick", function(self)

	local value = ceil(EditBoxHeight:GetText())
	
	PowerTrackerBarSettings.SliderHeightvalue = value
	
	PTBarBG:SetHeight(value)
	SliderHeight:SetValue(value)
end
);


-- Slider for Transparency (opacity)
local SliderTransparency = CreateFrame("Slider","PowerTrackerBarSliderTransparency",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderTransparency:SetPoint("TOPLEFT",40,-180)
_G[SliderTransparency:GetName() .. 'Low']:SetText('0%');
_G[SliderTransparency:GetName() .. 'High']:SetText('100%');
SliderTransparency:SetMinMaxValues(0, 1)
SliderTransparency:SetValueStep(.01)
--Save the Transparency in the SavedVariables and set the Transparency ingame (ingame Silder name: Opacity)
SliderTransparency:SetScript("OnValueChanged", function(self)
	local value_ = self:GetValue()
	local value = (ceil(value_*100))/100
	
	PowerTrackerBar_Transparency = value	
	PowerTrackerBarSettings.SliderTransparencyvalue = value
	
	PTBarBG:SetBackdropColor(0,0,0,value)
	PTBarBG:SetBackdropBorderColor(.2,.2,.2,value)
	
	if PowerTrackerBar_PowerColor == false or PowerTrackerBar_PowerColor == nil then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
		if class == "HUNTER" then
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		end
	elseif PowerTrackerBar_PowerColor == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];		
		if ( info ) then --The PowerBarColor takes priority			
			r, g, b = info.r, info.g, info.b;
		else
			if ( not altR) then
				-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
				info = PowerBarColor[powerType] or PowerBarColor["MANA"];
				r, g, b = info.r, info.g, info.b;
			else
				r, g, b = altR, altG, altB;
			end
		end
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
		if class == "HUNTER" then
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		end
	end	
	
	_G[SliderTransparency:GetName() .. 'Text']:SetText('Opacity: '.. ceil(SliderTransparency:GetValue()*100)..'%');
end)


-- Slider for Fontsize
local SliderFontsize = CreateFrame("Slider","PowerTrackerBarSliderFontsize",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderFontsize:SetPoint("TOPLEFT",40,-235)
_G[SliderFontsize:GetName() .. 'Low']:SetText('10');
_G[SliderFontsize:GetName() .. 'High']:SetText('35');
SliderFontsize:SetMinMaxValues(10, 35)
SliderFontsize:SetValueStep(1)
-- Save the Fontsize in the SavedVariables and set the Fontsize ingame
SliderFontsize:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderFontsizevalue = value
	
	PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, value, "THINOUTLINE")
	_G[SliderFontsize:GetName() .. 'Text']:SetText('Fontsize: '.. ceil(SliderFontsize:GetValue()));
end)


-- Option to hide the Bar out of combat
local HideOOCtext = PowerTrackerBar.panel:CreateFontString("text")
HideOOCtext:SetFontObject('GameFontNormalSmall')
HideOOCtext:SetPoint("TOPLEFT", 70,-305, "CENTER")
HideOOCtext:SetText('Only show in combat')
local HideOOC = CreateFrame("CheckButton", "PowerTrackerBarHideOOC", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
HideOOC:SetPoint("TOPLEFT", 40, -300, "CENTER");
HideOOC.tooltip = "Show the PowerTrackerBar only in combat";
-- Save option in the SavedVariables and set the Fontsize ingame and apply ingame
HideOOC:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.HideOOCvalue = state
	
	if self:GetChecked() == true then
		PTBarBG:Hide()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Hide()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	elseif self:GetChecked() == false then
		PTBarBG:Show()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Show()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end
);
-- Load the value from the SavedVariables, set the checkbox and apply ingame
HideOOC:RegisterEvent("ADDON_LOADED")
HideOOC:SetScript("OnEvent", function(self)
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.HideOOCvalue == nil then
		HideOOC:SetChecked(false)
	elseif PowerTrackerBarSettings.HideOOCvalue == true then
		HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)
		PTBarBG:Hide()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Hide()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
		
	else HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)		
	end
end)

-- PowerColor
local PowerColorText = PowerTrackerBar.panel:CreateFontString("text")
PowerColorText:SetFontObject('GameFontNormalSmall')
PowerColorText:SetPoint("TOPLEFT", 70,-325, "CENTER")
PowerColorText:SetText('Use power type color instead of class color')
local PowerColor = CreateFrame("CheckButton", "PowerTrackerBarPowerColor", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PowerColor:SetPoint("TOPLEFT", 40, -320, "CENTER");
PowerColor.tooltip = "E.g. red in bear form & yellow in cat form instead of brown.";
-- Save option in the SavedVariables and set the Fontsize ingame and apply ingame
PowerColor:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PowerColorvalue = state
	PowerTrackerBar_PowerColor = state
	
	if self:GetChecked() == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];
		
		if ( info ) then
			--The PowerBarColor takes priority
			r, g, b = info.r, info.g, info.b;
		else
			if ( not altR) then
				-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
				info = PowerBarColor[powerType] or PowerBarColor["MANA"];
				r, g, b = info.r, info.g, info.b;
			else
				r, g, b = altR, altG, altB;
			end
		end
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
		if class == "HUNTER" then
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		end
	elseif self:GetChecked() == false then
		local _, class = UnitClass("player")
		local r,g,b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
		if class == "HUNTER" then
			PTBar_prediction:SetStatusBarColor(r,g,b,PowerTrackerBar_predictiontransparency)
		end
	end
end)
-- Load the value from the SavedVariables, set the checkbox and apply ingame
PowerColor:RegisterEvent("ADDON_LOADED")
PowerColor:SetScript("OnEvent", function(self)
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PowerColorvalue == nil then
		PowerColor:SetChecked(false)
	elseif PowerTrackerBarSettings.PowerColorvalue == false then
		PowerColor:SetChecked(false)
	elseif PowerTrackerBarSettings.PowerColorvalue == true then
		PowerColor:SetChecked(true)
	end	
end)


-- Set the Silder to the SavedVariables values, if SavedVariables == nil set to default
PowerTrackerBar.panel.refresh = function()
	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		SliderWidth:SetValue(181)
	else
		SliderWidth:SetValue(PowerTrackerBarSettings.SliderWidthvalue)
	end
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		SliderHeight:SetValue(26)
	else
		SliderHeight:SetValue(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		SliderTransparency:SetValue(.7)
	else
		SliderTransparency:SetValue(PowerTrackerBarSettings.SliderTransparencyvalue)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		SliderFontsize:SetValue(16)
	else
		SliderFontsize:SetValue(PowerTrackerBarSettings.SliderFontsizevalue)
	end
end

-- Option to merge Combopoints with Anticipation stacks. E.g. 5cp + 2 Anticipation gets displayed as 7
if class == "ROGUE" then
	
	local SettingstextRogue = PowerTrackerBar.panel:CreateFontString("SettingstextRogue")
	SettingstextRogue:SetFontObject('GameFontNormalSmall')
	SettingstextRogue:SetPoint("TOPLEFT", 70,-345, "CENTER")
	SettingstextRogue:SetText('Merge Combopoints with Anticipation')
	
	MergeCP = CreateFrame("CheckButton", "PowerTrackerBarMergeCP", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
	MergeCP:SetPoint("TOPLEFT", 40, -340, "CENTER");
	MergeCP.tooltip = "Merge Combopoints with Anticipation stacks. E.g. 5cp + 2 Anticipation gets displayed as 7.";
	
	MergeCP:SetScript("OnClick", function(self)
		local state = self:GetChecked()
		
		PowerTrackerBarSettings.MergeCPvalue = state
		
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local anticipation_selected = select(4, GetTalentInfoByID(19250, GetActiveSpecGroup()))
		local anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
		
		if class == "ROGUE" then anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
			if not anticipation_stacks then anticipation_stacks = 0 end
		end		
		if anticipation_selected == true then
			if self:GetChecked() == true then
				PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower+anticipation_stacks)
			elseif self:GetChecked() == false then
				PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower .. ' - ' .. anticipation_stacks)
			end
		else
			PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
		end
	end
	);
	MergeCP:RegisterEvent("ADDON_LOADED")
	MergeCP:SetScript("OnEvent", function(self)
		
		if PowerTrackerBarSettings.MergeCPvalue == nil then
			MergeCP:SetChecked(false)
		else
			MergeCP:SetChecked(PowerTrackerBarSettings.MergeCPvalue)
		end
	end)
end


-- Create Resize frame in the bottom right corner
local resizeButton = CreateFrame("Button", nil, PTBarBG)
resizeButton:SetSize(16, 16)
resizeButton:SetPoint("CENTER", PTBar, "BOTTOMRIGHT")
resizeButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
resizeButton:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
resizeButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
--hide it in default state
resizeButton:RegisterEvent("PLAYER_ENTERING_WORLD")
resizeButton:SetScript("OnEvent", function(self)
	self:Hide()
end)

--slash command (drag to move or hold lower right corner to resize)
local PTBmove = false 
local function POWER()
	if not PTBmove then
		-- Resize:
		resizeButton:Show()
		resizeButton:SetScript("OnMouseDown", function(self, button) 	-- allows resizing of the frame while clicking on the Resize frame
			PTBarBG:StartSizing("BOTTOMRIGHT")
			PTBarBG:SetUserPlaced(true)
		end)
		resizeButton:SetScript("OnMouseUp", function(self, button)
			PTBarBG:StopMovingOrSizing()
		end)
		-- Drag:
		PTBarBG:RegisterForDrag("LeftButton")
		PTBarBG:SetScript("OnDragStart", PTBarBG.StartMoving)
		PTBarBG:SetScript("OnDragStop", PTBarBG.StopMovingOrSizing)
		
		print("Power Tracker Bar unlocked, type /ptb to save. Bar width, Bar height, Fontsize and Opacity can be set in the option menu (Esc -> Interface -> AddOns -> PowertTrackerBar)")
		PTBmove = true
		PTBarBG:EnableMouse(true)
	elseif PTBmove == true then
		resizeButton:Hide()
		if PTBarBG:GetWidth() <= 40 then PTBarBG:SetWidth(40) end
		if PTBarBG:GetHeight() <= 20 then PTBarBG:SetHeight(20) end
		PowerTrackerBarSettings.SliderWidthvalue = PTBarBG:GetWidth() -- save new width/height in SavedVariables
		PowerTrackerBarSettings.SliderHeightvalue = PTBarBG:GetHeight() -- save new width/height in SavedVariables
		PowerTrackerBarSettings.PTBarBG_point = select(1,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_relativeTo = select(2,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_relativePoint = select(3,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_xOfs = select(4,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_yOfs = select(5,PTBarBG:GetPoint())
		PTBarBG:EnableMouse(false)
		PTBmove = false
		print("Power Tracker Bar locked")
	end
end
SLASH_POWER1 = "/PTB"
SlashCmdList["POWER"] = POWER
